<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;

return new class extends Migration {
    /**
     * Run the migrations.
     */
    public function up(): void {
        Schema::create('clients', function (Blueprint $table)
        {
            $table->id();
            $table->foreignId('solicitor_id')->nullable()
                ->constrained()
                ->cascadeOnDelete();
            $table->foreignId('tranche_id')->nullable()->constrained()->nullOnDelete();
            $table->uuid('slug')->index()->unique();
            $table->string('reference')->nullable()->index();
            $table->foreignId('lead_source_id')
                ->nullable()
                ->index()
                ->constrained()
                ->onDelete('set null');
            $table->foreignId('lead_source_endpoint_id')
                ->nullable()
                ->index()
                ->constrained()
                ->onDelete('set null');
            $table->string('name_first')->index();
            $table->string('name_middle')->nullable();
            $table->string('name_last')->index();
            $table->string('name_preferred')->nullable()->index();
            $table->date('date_of_birth');
            $table->string('email_address')->unique()->index();
            $table->string('phone_number')->unique()->index();
            $table->json('preferences')->nullable();
            $table->timestamps();
            $table->softDeletes();
        });
    }

    /**
     * Reverse the migrations.
     */
    public function down(): void {
        Schema::dropIfExists('clients');
    }
};
